<?php

/* Copyright by Ingmar Mohring and Bjoern Wilmsmann, gamigo AG */
/* Do not remove copyright notice */  

class kontocheck {
  var $bankHash;
  var $pfad="./";

  function getBankHash ($pfad) {
    $fp = fopen ($pfad . "blz.txt", "r");
    while (!feof ($fp)) {
      $zeile = explode (";", fgets ($fp, 65536));
      $bankHash["$zeile[0]"]["bezeichnung"] = $zeile[1];
      $bankHash["$zeile[0]"]["plz"] = $zeile[2];
      $bankHash["$zeile[0]"]["ort"] = $zeile[3];
      $bankHash["$zeile[0]"]["verfahren"] = $zeile[4];
    }
    fclose ($fp);
    $bankHashSerialized = addslashes (serialize ($bankHash));
    $fp = fopen ($pfad . "blz.hash", "w");
    fputs ($fp, $bankHashSerialized);
    fclose ($fp);
    chmod ($pfad . "blz.hash", 0755);
  }

  function getUpdate ($pfad) {
    copy ($pfad . "blz.txt", $pfad . "blz.txt.safe");
    $fpInput = @fopen ("blz.txt", "r");
    $fpOutput = fopen ($pfad . "blz.txt", "w");
    if ($fpInput && $fpOutput) {
      $returnValue = 1;
    } else {
      $returnValue = 0;
    }
    fwrite ($fpOutput, fread ($fpInput, filesize ($pfad . "blz.txt")));
    fclose ($fpInput);
    fclose ($fpOutput);
    chmod ($pfad . "blz.txt", 0755);
    chmod ($pfad . "blz.txt.safe", 0755);
    return $returnValue;
  }
  
  function kontocheck() {
    //Hash laden 
    if (!file_exists ($this->pfad . "blz.hash")) {
      $this->getBankHash ($this->pfad);
    }
    $fp = fopen ($this->pfad . "blz.hash", "r");
    $this->bankHash = unserialize (stripslashes (fread ($fp, filesize ($this->pfad . "blz.hash"))));
    fclose ($fp); 
  }
 
  function verfahren_00 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  } // Ende 00

  function verfahren_01 ($ktonr) {
	$val9=intval(intval($ktonr[8])*3);
	$val8=intval(intval($ktonr[7])*7);
	$val7=intval(intval($ktonr[6])*1);
	$val6=intval(intval($ktonr[5])*3);
	$val5=intval(intval($ktonr[4])*7);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*3);
	$val2=intval(intval($ktonr[1])*7);
	$val1=intval(intval($ktonr[0])*1);
	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=10- intval($ges % 10);
        if ($rest=="10") { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  } // Ende 01

  function verfahren_02 ($kontonummer) {
    $overall = 0;
    $iteration = 1;
    $j = 8;
    $k = 1;
    while ($iteration <= 8) {
      if ($k == 1) {
        $produkte[$iteration] = $kontonummer[$j] * 2;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 2) {
        $produkte[$iteration] = $kontonummer[$j] * 3;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 3) {
        $produkte[$iteration] = $kontonummer[$j] * 4;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 4) {
        $produkte[$iteration] = $kontonummer[$j] * 5;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 5) {
        $produkte[$iteration] = $kontonummer[$j] * 6;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 6) {
        $produkte[$iteration] = $kontonummer[$j] * 7;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 7) {
        $produkte[$iteration] = $kontonummer[$j] * 8;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 8) {
        $produkte[$iteration] = $kontonummer[$j] * 9;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 9) {
        $produkte[$iteration] = $kontonummer[$j] * 2;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
        $k = 1;
      }
      $overall += $this->quersumme[$iteration];
      $iteration++;
      $j--;
      $k++;
    }
    $stelle = strlen ($overall);
    $overall = $overall % 11;
    $overallcast = "$overall";
    $pruefziffer = 11 - $overallcast;
    if ($pruefziffer == 11) {
      $pruefziffer = 0;
    }
    if ($pruefziffer == 10) {
      $return_value = 0;
    } else {
      if ($pruefziffer == $kontonummer[9]) {
        $return_value = 1;
      } else {
        $return_value = 0;
      }
    }
    return $return_value;
  }
  function verfahren_03 ($kontonummer) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=10- intval($ges % 10);
        if ($rest=="10") { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  }
  function verfahren_04 ($kontonummer) {
    $overall = 0;
    $iteration = 1;
    $j = 8;
    $k = 1;
    while ($iteration <= 8) {
      if ($k == 1) {
        $produkte[$iteration] = $kontonummer[$j] * 2;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 2) {
        $produkte[$iteration] = $kontonummer[$j] * 3;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 3) {
        $produkte[$iteration] = $kontonummer[$j] * 4;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 4) {
        $produkte[$iteration] = $kontonummer[$j] * 5;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 5) {
        $produkte[$iteration] = $kontonummer[$j] * 6;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 6) {
        $produkte[$iteration] = $kontonummer[$j] * 7;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 7) {
        $produkte[$iteration] = $kontonummer[$j] * 2;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 8) {
        $produkte[$iteration] = $kontonummer[$j] * 3;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 9) {
        $produkte[$iteration] = $kontonummer[$j] * 4;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
        $k = 1;
      }
      $overall += $this->quersumme[$iteration];
      $iteration++;
      $j--;
      $k++;
    }
    $stelle = strlen ($overall);
    $overall = $overall % 11;
    $overallcast = "$overall";
    $pruefziffer = 11 - $overallcast;
    if ($pruefziffer == 11) {
      $pruefziffer = 0;
    }
    if ($pruefziffer == 10) {
      $return_value = 0;
    } else {
      if ($pruefziffer == $kontonummer[9]) {
        $return_value = 1;
      } else {
        $return_value = 0;
      }
    }
    return $return_value;
  }

  function verfahren_05 ($ktonr) {
	$val9=intval(intval($ktonr[8])*7);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*1);
	$val6=intval(intval($ktonr[5])*7);
	$val5=intval(intval($ktonr[4])*3);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*7);
	$val2=intval(intval($ktonr[1])*3);
	$val1=intval(intval($ktonr[0])*1);
	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=10- intval($ges % 10);
        if ($rest=="10") { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  }

function verfahren_06 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*3);
	$val1=intval(intval($ktonr[0])*4);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 06

  function verfahren_07 ($kontonummer) {
    $overall = 0;
    $iteration = 1;
    $j = 8;
    $k = 1;
    while ($iteration <= 8) {
      if ($k == 1) {
        $produkte[$iteration] = $kontonummer[$j] * 2;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 2) {
        $produkte[$iteration] = $kontonummer[$j] * 3;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 3) {
        $produkte[$iteration] = $kontonummer[$j] * 4;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 4) {
        $produkte[$iteration] = $kontonummer[$j] * 5;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 5) {
        $produkte[$iteration] = $kontonummer[$j] * 6;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 6) {
        $produkte[$iteration] = $kontonummer[$j] * 7;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 7) {
        $produkte[$iteration] = $kontonummer[$j] * 8;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 8) {
        $produkte[$iteration] = $kontonummer[$j] * 9;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 9) {
        $produkte[$iteration] = $kontonummer[$j] * 10;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
        $k = 1;
      }
      $overall += $this->quersumme[$iteration];
      $iteration++;
      $j--;
      $k++;
    }
    $stelle = strlen ($overall);
    $overall = $overall % 11;
    $overallcast = "$overall";
    $pruefziffer = 11 - $overallcast;
    if ($pruefziffer == 1) {
      $return_value = 0;
    } else {
      if ($pruefziffer == $kontonummer[9]) {
        $return_value = 1;
      } else {
        $return_value = 0;
      }
    }
    return $return_value;
} // Ende 07

  function verfahren_08 ($kontonummer) {
    if ($kontonummer > 60000) {
      $overall = 0;
      $iteration = 1;
      $j = 8;
      while ($iteration <= 9) {
        if (($iteration % 2) == 0) {
          $produkte[$iteration] = $kontonummer[$j] * 1;
          $produktcast = "$produkte[$iteration]";
          $this->quersumme[$iteration] = $produktcast;
        } else {
          $produkte[$iteration] = $kontonummer[$j] * 2;
          if ($produkte[$iteration] > 9) {
            $produktcast = "$produkte[$iteration]";
            $this->quersumme[$iteration] = $produktcast[0] + $produktcast[1];
          } else {
            $produktcast = "$produkte[$iteration]";
            $this->quersumme[$iteration] = $produktcast;
          }
        }
        $overall += $this->quersumme[$iteration];
        $iteration++;
        $j--;
      }
      $stelle = strlen ($overall);
      $overallcast = "$overall";
      if ($stelle == 1) {
        $pruefziffer = 10 - $overallcast;
      } else {
        $pruefziffer = 10 - $overallcast [$stelle - 1];
      }
      if ($pruefziffer == $kontonummer[9]) {
        $return_value = 1;
      } else {
        $return_value = 0;
      }
      return $return_value;
    } else {
      $return_value = 0;
    }
  } // Ende 08

function verfahren_09 ($ktonr) {
  return 1; // Alle Kontonummern fuer Verfahren 9 gelten als gueltig
}  // Ende 09

function verfahren_10 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*8);
	$val2=intval(intval($ktonr[1])*9);
	$val1=intval(intval($ktonr[0])*10);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
}  // Ende 10

function verfahren_11 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*8);
	$val2=intval(intval($ktonr[1])*9);
	$val1=intval(intval($ktonr[0])*10);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { if ($rest==1) { $pruef=9; } else { $pruef=0; } } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
}  // Ende 11

  function verfahren_12 ($kontonummer) {
    $overall = 0;
    $iteration = 1;
    $j = 8;
    $k = 1;
    while ($iteration <= 8) {
      if ($k == 1) {
        $produkte[$iteration] = $kontonummer[$j] * 1;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 2) {
        $produkte[$iteration] = $kontonummer[$j] * 3;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 3) {
        $produkte[$iteration] = $kontonummer[$j] * 7;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
        $k = 1;
      }
      $overall += $this->quersumme[$iteration];
      $iteration++;
      $j--;
      $k++;
    }
    $stelle = strlen ($overall);
    $overallcast = "$overall";
    if ($stelle == 1) {
      $pruefziffer = 10 - $overallcast;
    } else {
      $pruefziffer = 10 - $overallcast [$stelle - 1];
    }
    if ($pruefziffer == $kontonummer[9]) {
      $return_value = 1;
    } else {
      $return_value = 0;
    }
    return $return_value;
  } // Ende 12

function verfahren_13 ($ktonr) {
  $val7=intval(intval($ktonr[6])*2);
  $val6=intval(intval($ktonr[5])*1);
  $val5=intval(intval($ktonr[4])*2);
  $val4=intval(intval($ktonr[3])*1);
  $val3=intval(intval($ktonr[2])*2);
  $val2=intval(intval($ktonr[1])*1);
  if ($val2>9) { $val2 = "$val2"; $val2 = $val2[0] + $val2[1]; }
  if ($val3>9) { $val3 = "$val3"; $val3 = $val3[0] + $val3[1]; }
  if ($val4>9) { $val4 = "$val4"; $val4 = $val4[0] + $val4[1]; }
  if ($val5>9) { $val5 = "$val5"; $val5 = $val5[0] + $val5[1]; }
  if ($val6>9) { $val6 = "$val6"; $val6 = $val6[0] + $val6[1]; }
  if ($val7>9) { $val7 = "$val7"; $val7 = $val7[0] + $val7[1]; }
  $ges=intval($val2+$val3+$val4+$val5+$val6+$val7);
  $ges = "$ges";
  if ((strlen ($ges)) > 1) {
    $pruef= 10 - $ges[1];
    // Wenn 10 - Pruefziffer == 0, setze $pruef = 0
    if ($pruef == 10) { $pruef = 0; } 
  }
  else {
    $pruef = 10 - $ges;
    // Wenn 10 - Pruefziffer == 0, setze $pruef = 0
    if ($pruef == 10) { $pruef = 0; } 
  }
  if (intval($pruef)==intval($ktonr[7])) { return 1; }
  else {
    if (($ktonr[8]+$ktonr[9]) != 0) {
      $cache[0]=$ktonr[2];
      $cache[1]=$ktonr[3];
      $cache[2]=$ktonr[4];
      $cache[3]=$ktonr[5];
      $cache[4]=$ktonr[6];
      $cache[5]=$ktonr[7];
      $cache[6]=$ktonr[8];
      $cache[7]=$ktonr[9];
      $cache[8]=0;
      $cache[9]=0;
      $ktonr="";
      for ($i=0; $i<=9; $i++) {
        $ktonr.=$cache[$i];
      }
      if (($this->verfahren_13 ($ktonr) == 1)) {
        return 1;
      } else {
        return 0;
      }
    } else {
      return 0;
    }
  }
} // Ende 13

  function verfahren_14 ($kontonummer) {
    $overall = 0;
    $iteration = 1;
    $j = 8;
    $k = 4;
    while ($iteration <= 8) {
      if ($k == 4) {
        $produkte[$iteration] = $kontonummer[$j] * 2;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 5) {
        $produkte[$iteration] = $kontonummer[$j] * 3;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 6) {
        $produkte[$iteration] = $kontonummer[$j] * 4;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 7) {
        $produkte[$iteration] = $kontonummer[$j] * 5;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 8) {
        $produkte[$iteration] = $kontonummer[$j] * 6;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      if ($k == 9) {
        $produkte[$iteration] = $kontonummer[$j] * 7;
        $produktcast = "$produkte[$iteration]";
        $this->quersumme[$iteration] = $produktcast;
      }
      $overall += $this->quersumme[$iteration];
      $iteration++;
      $j--;
      $k++;
    }
    $stelle = strlen ($overall);
    $overall = $overall % 11;
    $overallcast = "$overall";
    $pruefziffer = 11 - $overallcast;
    if ($pruefziffer == 11) {
      $pruefziffer = 0;
    }
    if ($pruefziffer == 10) {
      $return_value = 0;
    } else {
      if ($pruefziffer == $kontonummer[9]) {
        $return_value = 1;
      } else {
        $return_value = 0;
      }
    }
    return $return_value;
  } // Ende 14

function verfahren_15 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);

	$ges=intval($val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
}  // Ende 15

function verfahren_16 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*3);
	$val1=intval(intval($ktonr[0])*4);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

        if ($rest == 1) {
          if ($ktonr[8] == $ktonr[9]) {
            return 1;
          } else {
            return 0;
          }
        } else {
	  if (intval($pruef)==intval($ktonr[9])) {return 1; }
	  else { return 0; }
	}
} // Ende 16

function verfahren_17 ($ktonr) {
  $summe = 0;
  for ($i = 1; $i <= 6; $i++) {
    switch ($i % 2) {
      case 1 :
        $summe += $this->quersumme ($ktonr[$i] * 1);
	break;
      case 0 :
        $summe += $this->quersumme ($ktonr[$i] * 2);
	break;
    }
  }
  $summe -= 1;
  $pruefziffer = 10 - $summe % 11;
  if ($pruefziffer == 10) {
    $pruefziffer = 0;
  }
  if ($pruefziffer == $ktonr[$i]) {
    $returnValue = 1;
  } else {
    $returnValue = 0;
  }
  return $returnValue;
} // Ende 17

  function verfahren_18 ($ktonr) {
	$val9=intval(intval($ktonr[8])*3);
	$val8=intval(intval($ktonr[7])*9);
	$val7=intval(intval($ktonr[6])*7);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*3);
	$val4=intval(intval($ktonr[3])*9);
	$val3=intval(intval($ktonr[2])*7);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*3);
	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=10- intval($ges % 10);
        if ($rest=="10") { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  } // Ende 18

function verfahren_19 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*8);
	$val2=intval(intval($ktonr[1])*9);
	$val1=intval(intval($ktonr[0])*1);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
}  // Ende 19

function verfahren_20 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*8);
	$val2=intval(intval($ktonr[1])*9);
	$val1=intval(intval($ktonr[0])*3);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
}  // Ende 20

  function verfahren_21 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	while ($ges > 9) {
	  $ges = $this->quersumme ($ges);
	}
	$rest=10-intval($ges % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  } // Ende 21

  function verfahren_22 ($ktonr) {
	$val9=intval(intval($ktonr[8])*3);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*3);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*3);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*3);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*3);
	for ($i = 1; $i <= 9; $i++) {
	  $varToProcess = "val$i";
	  $varEinerToProcess = "valEiner$i";
	  $$varToProcess = strval ($$varToProcess);
	  $varLength = strlen ($$varToProcess);
	  if ($varLength > 1) {
	    for ($j = 1; $j < $varLength; $j++) {
	      $$varEinerToProcess = $$varToProcess[$j];
	    }
	  } else {
	    $$varEinerToProcess = $$varToProcess;
	  }
	}
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$rest=10-intval($ges % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  } // Ende 22

function verfahren_23 ($ktonr) {
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*3);
	$val1=intval(intval($ktonr[0])*4);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

        if ($rest == 1) {
          if ($ktonr[5] == $ktonr[6]) {
            return 1;
          } else {
            return 0;
          }
        } else {
	  if (intval($pruef)==intval($ktonr[6])) {return 1; }
	  else { return 0; }
	}
} // Ende 23

function verfahren_24 ($ktonr) {
  $summe = 0;
  if ($ktonr[0] == 3 || $ktonr[0] == 4 || $ktonr[0] == 5 || $ktonr[0] == 6) {
    $ktonr[0] = 0;
  }
  if ($ktonr[0] == 9) {
    $ktonr[0] = 0;
    $ktonr[1] = 0;
    $ktonr[2] = 0;
  }
  $ktonr = strval (doubleval ($ktonr));
  for ($i = 0; $i <= strlen ($ktonr) - 2; $i++) {
    switch ($i % 3) {
      case 0 :
        $summe += ($ktonr[$i] * 1 + 1) % 11;
	break;
      case 1 :
        $summe += ($ktonr[$i] * 2 + 2) % 11;
	break;
      case 2 :
        $summe += ($ktonr[$i] * 3 + 3) % 11;
	break;
    }
  }
  $summe = strval ($summe);
  $summeLength = strlen ($summe);
  if ($summeLength > 1) {
    for ($j = 1; $j < $summeLength; $j++) {
      $pruefziffer = $summe[$j];
    }
  } else {
    $pruefziffer = $summe;
  }
  if ($pruefziffer == $ktonr[$i]) {
    $returnValue = 1;
  } else {
    $returnValue = 0;
  }
  return $returnValue;
} // Ende 24

function verfahren_25 ($ktonr) {

	$val8=intval(intval($ktonr[8])*2);
	$val7=intval(intval($ktonr[7])*3);
	$val6=intval(intval($ktonr[6])*4);
	$val5=intval(intval($ktonr[5])*5);
	$val4=intval(intval($ktonr[4])*6);
	$val3=intval(intval($ktonr[3])*7);
	$val2=intval(intval($ktonr[2])*8);
	$val1=intval(intval($ktonr[1])*9);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
}  // Ende 25

function verfahren_26 ($ktonr) {
	if ($ktonr[0] == 0 && $ktonr[1] == 0) {
	  $ktonr = substr ($ktonr, 2) . "00";
	}
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*3);
	$val5=intval(intval($ktonr[4])*4);
	$val4=intval(intval($ktonr[3])*5);
	$val3=intval(intval($ktonr[2])*6);
	$val2=intval(intval($ktonr[1])*7);
	$val1=intval(intval($ktonr[0])*2);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[7])) { return 1; }
	else { return 0; }
} // Ende 26

  function verfahren_27 ($ktonr) {
    if (intval ($ktonr) >=1 && intval ($ktonr) <= 999999999) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { $returnValue = 1; }
	else { $returnValue = 0; }
    } else {
	// Transformationsmatrix (Verfahren M10H)
	$summe = 0;
	$zeile1 = array (0, 1, 5, 9, 3, 7, 4, 8, 2, 6);
	$zeile2 = array (0, 1, 7, 6, 9, 8, 3, 2, 5, 4);
	$zeile3 = array (0, 1, 8, 4, 6, 2, 9, 5, 7, 3);
	$zeile4 = array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
	$length = strlen ($ktonr) - 1;
	for ($i = 0; $i < $length ; $i++) {
	  switch ($i % 4) {
	    case 0:
	      $summe += $zeile1[$ktonr[$length - 1 - $i]];
	      break;
	    case 1:
	      $summe += $zeile2[$ktonr[$length - 1 - $i]];
	      break;
	    case 2:
	      $summe += $zeile3[$ktonr[$length - 1 - $i]];
	      break;
	    case 3:
	      $summe += $zeile4[$ktonr[$length - 1 - $i]];
	      break;
	  }
	}
	$summe = strval ($summe);
	$summeLength = strlen ($summe);
	if ($summeLength > 1) {
	  for ($j = 1; $j < $summeLength; $j++) {
	    $summeEiner = $summe[$j];
	  }
	} else {
	  $summeEiner = $summe;
	}
	$pruefziffer = 10 - $summeEiner;
	if ($pruefziffer == $ktonr[$i]) {
	  $returnValue = 1;
	} else {
	  $returnValue = 0;
	}
    }
    return $returnValue;
  } // Ende 27

function verfahren_28 ($ktonr) {

	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*3);
	$val5=intval(intval($ktonr[4])*4);
	$val4=intval(intval($ktonr[3])*5);
	$val3=intval(intval($ktonr[2])*6);
	$val2=intval(intval($ktonr[1])*7);
	$val1=intval(intval($ktonr[0])*8);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[7])) { return 1; }
	else { return 0; }
}  // Ende 28

function verfahren_29 ($ktonr) {
  // Transformationsmatrix
  $summe = 0;
  $zeile1 = array (0, 1, 5, 9, 3, 7, 4, 8, 2, 6);
  $zeile2 = array (0, 1, 7, 6, 9, 8, 3, 2, 5, 4);
  $zeile3 = array (0, 1, 8, 4, 6, 2, 9, 5, 7, 3);
  $zeile4 = array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  $length = strlen ($ktonr) - 1;
  for ($i = 0; $i < $length ; $i++) {
    switch ($i % 4) {
      case 0:
        $summe += $zeile1[$ktonr[$length - 1 - $i]];
        break;
      case 1:
        $summe += $zeile2[$ktonr[$length - 1 - $i]];
        break;
      case 2:
        $summe += $zeile3[$ktonr[$length - 1 - $i]];
        break;
      case 3:
        $summe += $zeile4[$ktonr[$length - 1 - $i]];
        break;
    }
  }
  $summe = strval ($summe);
  $summeLength = strlen ($summe);
  if ($summeLength > 1) {
    for ($j = 1; $j < $summeLength; $j++) {
      $summeEiner = $summe[$j];
    }
  } else {
    $summeEiner = $summe;
  }
  $pruefziffer = 10 - $summeEiner;
  if ($pruefziffer == $ktonr[$i]) {
    $returnValue = 1;
  } else {
    $returnValue = 0;
  }
  return $returnValue;
} // Ende 29

  function verfahren_30 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*0);
	$val4=intval(intval($ktonr[3])*0);
	$val3=intval(intval($ktonr[2])*0);
	$val2=intval(intval($ktonr[1])*0);
	$val1=intval(intval($ktonr[0])*2);
        $ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  } // Ende 30

  function verfahren_31 ($ktonr) {
	$val9=intval(intval($ktonr[8])*9);
	$val8=intval(intval($ktonr[7])*8);
	$val7=intval(intval($ktonr[6])*7);
	$val6=intval(intval($ktonr[5])*6);
	$val5=intval(intval($ktonr[4])*5);
	$val4=intval(intval($ktonr[3])*4);
	$val3=intval(intval($ktonr[2])*3);
	$val2=intval(intval($ktonr[1])*2);
	$val1=intval(intval($ktonr[0])*1);
        $ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$pruef = $ges % 11;
	if (intval($pruef)==intval($ktonr[9]) && $pruef != 10) { return 1; }
	else { return 0; }
  } // Ende 31

function verfahren_32 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);

	$ges=intval($val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 32

function verfahren_33 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);

	$ges=intval($val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 33

function verfahren_34 ($ktonr) {

	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*4);
	$val5=intval(intval($ktonr[4])*8);
	$val4=intval(intval($ktonr[3])*5);
	$val3=intval(intval($ktonr[2])*10);
	$val2=intval(intval($ktonr[1])*9);
	$val1=intval(intval($ktonr[0])*7);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[7])) { return 1; }
	else { return 0; }
}  // Ende 34

  function verfahren_35 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*8);
	$val2=intval(intval($ktonr[1])*9);
	$val1=intval(intval($ktonr[0])*10);
        $ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$pruef = $ges % 11;
	if (intval($pruef)==intval($ktonr[9]) || ($pruef == 10 && $ktonr[9] == $ktonr[8])) { return 1; }
	else { return 0; }
  } // Ende 35

function verfahren_36 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*4);
	$val7=intval(intval($ktonr[6])*8);
	$val6=intval(intval($ktonr[5])*5);

	$ges=intval($val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 36

function verfahren_37 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*4);
	$val7=intval(intval($ktonr[6])*8);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*10);

	$ges=intval($val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 37

function verfahren_38 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*4);
	$val7=intval(intval($ktonr[6])*8);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*10);
	$val4=intval(intval($ktonr[3])*9);

	$ges=intval($val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 38

function verfahren_39 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*4);
	$val7=intval(intval($ktonr[6])*8);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*10);
	$val4=intval(intval($ktonr[3])*9);
	$val3=intval(intval($ktonr[2])*7);

	$ges=intval($val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 39

function verfahren_40 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*4);
	$val7=intval(intval($ktonr[6])*8);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*10);
	$val4=intval(intval($ktonr[3])*9);
	$val3=intval(intval($ktonr[2])*7);
	$val2=intval(intval($ktonr[1])*3);
	$val1=intval(intval($ktonr[0])*6);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 40

  function verfahren_41 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
	if ($ktonr[3] != 9) {
          $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	} else {
          $ges=intval($this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	}
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  } // Ende 41

function verfahren_42 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*8);
	$val2=intval(intval($ktonr[1])*9);

	$ges=intval($val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 42

function verfahren_43 ($ktonr) {

	$val9=intval(intval($ktonr[8])*1);
	$val8=intval(intval($ktonr[7])*2);
	$val7=intval(intval($ktonr[6])*3);
	$val6=intval(intval($ktonr[5])*4);
	$val5=intval(intval($ktonr[4])*5);
	$val4=intval(intval($ktonr[3])*6);
	$val3=intval(intval($ktonr[2])*7);
	$val2=intval(intval($ktonr[1])*8);
	$val1=intval(intval($ktonr[0])*9);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 10;
	$pruef=intval(10 - $rest);

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 43

function verfahren_44 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*4);
	$val7=intval(intval($ktonr[6])*8);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*10);

	$ges=intval($val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 44

  function verfahren_45 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9]) || $ktonr[0] == 0 || $ktonr[4] == 1) { return 1; }
	else { return 0; }
  } // Ende 45

function verfahren_46 ($ktonr) {

	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*3);
	$val5=intval(intval($ktonr[4])*4);
	$val4=intval(intval($ktonr[3])*5);
	$val3=intval(intval($ktonr[2])*6);

	$ges=intval($val3+$val4+$val5+$val6+$val7);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[7])) { return 1; }
	else { return 0; }
} // Ende 46

function verfahren_47 ($ktonr) {

	$val8=intval(intval($ktonr[7])*2);
	$val7=intval(intval($ktonr[6])*3);
	$val6=intval(intval($ktonr[5])*4);
	$val5=intval(intval($ktonr[4])*5);
	$val4=intval(intval($ktonr[3])*6);

	$ges=intval($val4+$val5+$val6+$val7+$val8);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[8])) { return 1; }
	else { return 0; }
} // Ende 47

function verfahren_48 ($ktonr) {

	$val8=intval(intval($ktonr[7])*2);
	$val7=intval(intval($ktonr[6])*3);
	$val6=intval(intval($ktonr[5])*4);
	$val5=intval(intval($ktonr[4])*5);
	$val4=intval(intval($ktonr[3])*6);
	$val3=intval(intval($ktonr[2])*7);

	$ges=intval($val3+$val4+$val5+$val6+$val7+$val8);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; }
 
	if (intval($pruef)==intval($ktonr[8])) { return 1; }
	else { return 0; }
} // Ende 48

function verfahren_49 ($ktonr) {
  $returnValue = $this->verfahren_00 ($ktonr);
  if ($returnValue == 0) {
    $returnValue = $this->verfahren_01 ($ktonr);
  }
  return $returnValue;
} // Ende 49

function verfahren_50 ($ktonr) {

	$val6=intval(intval($ktonr[5])*2);
	$val5=intval(intval($ktonr[4])*3);
	$val4=intval(intval($ktonr[3])*4);
	$val3=intval(intval($ktonr[2])*5);
	$val2=intval(intval($ktonr[1])*6);
	$val1=intval(intval($ktonr[0])*7);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6);
	$rest=$ges % 11;
	if ($rest>1) {
	  $pruef=intval(11 - $rest);
	} else {
          $pruef=0;
	}
	if (intval($pruef)==intval($ktonr[6])) {
	  return 1;
	} else {
	  if (substr ($ktonr, 7, 3) != "000") {
	    return $this->verfahren_50 (substr ($ktonr, 3, 7) . "000");
	  } else {
	    return 0;
	  }
	}
} // Ende 50

function verfahren_51 ($ktonr) {
 //AUSNAHME
 if($ktonr[2].$ktonr[3] == 99)
 {
  $val9=intval(intval($ktonr[8])*2);
  $val8=intval(intval($ktonr[7])*3);
  $val7=intval(intval($ktonr[6])*4);
  $val6=intval(intval($ktonr[5])*5);
  $val5=intval(intval($ktonr[4])*6);
  $val4=intval(intval($ktonr[3])*7);
  $val3=intval(intval($ktonr[2])*8);
  $val2=intval(intval($ktonr[1])*9);
  $val1=intval(intval($ktonr[0])*10);

  $ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
  $rest=$ges % 11;
  if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

  if (intval($pruef)==intval($ktonr[9])) { return 1; }
  else { return 0; } 
 }
 //METHODE A
 $val9=intval(intval($ktonr[8])*2);
 $val8=intval(intval($ktonr[7])*3);
 $val7=intval(intval($ktonr[6])*4);
 $val6=intval(intval($ktonr[5])*5);
 $val5=intval(intval($ktonr[4])*6);
 $val4=intval(intval($ktonr[3])*7);
 $val3=intval(intval($ktonr[2])*2);
 $val2=intval(intval($ktonr[1])*3);
 $val1=intval(intval($ktonr[0])*4);

 $ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
 $rest=$ges % 11;
 if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

 if (intval($pruef)==intval($ktonr[9])) 
 return 1;
 else 
 {
  //METHODE B
  $val9=intval(intval($ktonr[8])*2);
  $val8=intval(intval($ktonr[7])*3);
  $val7=intval(intval($ktonr[6])*4);
  $val6=intval(intval($ktonr[5])*5);
  $val5=intval(intval($ktonr[4])*6);

  $ges=intval($val5+$val6+$val7+$val8+$val9);
  $rest=$ges % 11;
  if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

  if (intval($pruef)==intval($ktonr[9]))
  return 1;
  else 
  {
   //METHODE C 
   if($ktonr[9] > 6) return 0;
   $val9=intval(intval($ktonr[8])*2);
   $val8=intval(intval($ktonr[7])*3);
   $val7=intval(intval($ktonr[6])*4);
   $val6=intval(intval($ktonr[5])*5);
   $val5=intval(intval($ktonr[4])*6);

   $ges=intval($val5+$val6+$val7+$val8+$val9);
   $rest=$ges % 7;
   if ($rest>1) { $pruef=intval(7 - $rest); } else { $pruef=0; } 
   return $pruef;
   
  }
 } 
} // Ende 51

function verfahren_55 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*8);
	$val2=intval(intval($ktonr[1])*7);
	$val1=intval(intval($ktonr[0])*8);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 55

  function verfahren_59 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9]) || strlen (strval ($ktonr)) < 9) { return 1; }
	else { return 0; }
  } // Ende 59

  function verfahren_60 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
        $ges=intval($this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  } // Ende 60

function verfahren_61 ($ktonr) {
  if ($ktonr[8] == 8) {
    $val10=intval(intval($ktonr[9])*2);
    $val9=intval(intval($ktonr[8])*1);
    $val7=intval(intval($ktonr[6])*2);
    $val6=intval(intval($ktonr[5])*1);
    $val5=intval(intval($ktonr[4])*2);
    $val4=intval(intval($ktonr[3])*1);
    $val3=intval(intval($ktonr[2])*2);
    $val2=intval(intval($ktonr[1])*1);
    $val1=intval(intval($ktonr[0])*2);
    if ($val1>9) { $val1 = "$val1"; $val1 = $val1[0] + $val1[1]; }
    if ($val2>9) { $val2 = "$val2"; $val2 = $val2[0] + $val2[1]; }
    if ($val3>9) { $val3 = "$val3"; $val3 = $val3[0] + $val3[1]; }
    if ($val4>9) { $val4 = "$val4"; $val4 = $val4[0] + $val4[1]; }
    if ($val5>9) { $val5 = "$val5"; $val5 = $val5[0] + $val5[1]; }
    if ($val6>9) { $val6 = "$val6"; $val6 = $val6[0] + $val6[1]; }
    if ($val7>9) { $val7 = "$val7"; $val7 = $val7[0] + $val7[1]; }
    if ($val9>9) { $val9 = "$val9"; $val9 = $val9[0] + $val9[1]; }
    if ($val10>9) { $val10 = "$val10"; $val10 = $val10[0] + $val10[1]; }
    $ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val9+$val10);
  } else {
    $val7=intval(intval($ktonr[6])*2);
    $val6=intval(intval($ktonr[5])*1);
    $val5=intval(intval($ktonr[4])*2);
    $val4=intval(intval($ktonr[3])*1);
    $val3=intval(intval($ktonr[2])*2);
    $val2=intval(intval($ktonr[1])*1);
    $val1=intval(intval($ktonr[0])*2);
    if ($val1>9) { $val1 = "$val1"; $val1 = $val1[0] + $val1[1]; }
    if ($val2>9) { $val2 = "$val2"; $val2 = $val2[0] + $val2[1]; }
    if ($val3>9) { $val3 = "$val3"; $val3 = $val3[0] + $val3[1]; }
    if ($val4>9) { $val4 = "$val4"; $val4 = $val4[0] + $val4[1]; }
    if ($val5>9) { $val5 = "$val5"; $val5 = $val5[0] + $val5[1]; }
    if ($val6>9) { $val6 = "$val6"; $val6 = $val6[0] + $val6[1]; }
    if ($val7>9) { $val7 = "$val7"; $val7 = $val7[0] + $val7[1]; }
    $ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7);
  }
  $ges = "$ges";
  if ((strlen ($ges)) > 1) { $pruef= 10 - $ges[1]; }
  else { $pruef= 10 - $ges; }
  if (intval($pruef)==intval($ktonr[7])) { return 1; }
  else { return 0; }
} // Ende 61

  function verfahren_62 ($ktonr) {
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
        $ges=intval($this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[7])) { return 1; }
	else { return 0; }
  } // Ende 62

function verfahren_63 ($ktonr) {
  if (($ktonr[8]+$ktonr[9]) == 0) {
    $val7=intval(intval($ktonr[6])*2);
    $val6=intval(intval($ktonr[5])*1);
    $val5=intval(intval($ktonr[4])*2);
    $val4=intval(intval($ktonr[3])*1);
    $val3=intval(intval($ktonr[2])*2);
    $val2=intval(intval($ktonr[1])*1);
    if ($val2>9) { $val2 = "$val2"; $val2 = $val2[0] + $val2[1]; }
    if ($val3>9) { $val3 = "$val3"; $val3 = $val3[0] + $val3[1]; }
    if ($val4>9) { $val4 = "$val4"; $val4 = $val4[0] + $val4[1]; }
    if ($val5>9) { $val5 = "$val5"; $val5 = $val5[0] + $val5[1]; }
    if ($val6>9) { $val6 = "$val6"; $val6 = $val6[0] + $val6[1]; }
    if ($val7>9) { $val7 = "$val7"; $val7 = $val7[0] + $val7[1]; }
    $ges=intval($val2+$val3+$val4+$val5+$val6+$val7);
    $pruefstelle = 7;
  } else {
    $val9=intval(intval($ktonr[8])*2);
    $val8=intval(intval($ktonr[7])*1);
    $val7=intval(intval($ktonr[6])*2);
    $val6=intval(intval($ktonr[5])*1);
    $val5=intval(intval($ktonr[4])*2);
    $val4=intval(intval($ktonr[3])*1);
    if ($val4>9) { $val4 = "$val4"; $val4 = $val4[0] + $val4[1]; }
    if ($val5>9) { $val5 = "$val5"; $val5 = $val5[0] + $val5[1]; }
    if ($val6>9) { $val6 = "$val6"; $val6 = $val6[0] + $val6[1]; }
    if ($val7>9) { $val7 = "$val7"; $val7 = $val7[0] + $val7[1]; }
    if ($val8>9) { $val8 = "$val8"; $val8 = $val8[0] + $val8[1]; }
    if ($val9>9) { $val9 = "$val9"; $val9 = $val9[0] + $val9[1]; }
    $ges=intval($val4+$val5+$val6+$val7+$val8+$val9);
    $pruefstelle = 9;
  }
  $ges = "$ges";
  if ((strlen ($ges)) > 1) {
    if($ges[1]==0) {
      $pruef=0;
    } else {
      $pruef= 10 - $ges[1];
    }
  }															
  else { $pruef= 10 - $ges; }
  if ($ktonr[0]!=0) { return 0; }
  else {
    if (intval($pruef)==intval($ktonr[$pruefstelle])) { return 1; }
    else { return 0; }
  }
} // Ende 63

function verfahren_64 ($ktonr) {

	$val6=intval(intval($ktonr[5])*2);
	$val5=intval(intval($ktonr[4])*4);
	$val4=intval(intval($ktonr[3])*8);
	$val3=intval(intval($ktonr[2])*5);
	$val2=intval(intval($ktonr[1])*10);
	$val1=intval(intval($ktonr[0])*9);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 
	if (intval($pruef)==intval($ktonr[6])) { return 1; }
	else { return 0; }
} // Ende 64

  function verfahren_67 ($ktonr) {
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[7])) { return 1; }
	else { return 0; }
  } // Ende 67

  function verfahren_68 ($kontonummer) {
    $kontonummer = strval (doubleval ($kontonummer));
    $length = strlen ($kontonummer);
    $pruefstelle = $length - 1;
    if ($length == 10) {
      $overall = 0;
      $iteration = 1;
      $j = 8;
      if ($kontonummer[3] == 9) {
        while ($iteration <= 6) {
          if (($iteration % 2) == 0) {
            $produkte[$iteration] = $kontonummer[$j] * 1;
            $produktcast = "$produkte[$iteration]";
            $this->quersumme[$iteration] = $produktcast;
          } else {
            $produkte[$iteration] = $kontonummer[$j] * 2;
            if ($produkte[$iteration] > 9) {
              $produktcast = "$produkte[$iteration]";
              $this->quersumme[$iteration] = $produktcast[0] + $produktcast[1];
            } else {
              $produktcast = "$produkte[$iteration]";
              $this->quersumme[$iteration] = $produktcast;
            }
          }
          $overall += $this->quersumme[$iteration];
          $iteration++;
          $j--;
        }
      } else {
        $overall = -1;
      }
      $stelle = strlen ($overall);
      $overallcast = "$overall";
      if ($stelle == 1) {
        $pruefziffer = 10 - $overallcast;
      } else {
        $pruefziffer = 10 - $overallcast [$stelle - 1];
      }
      if ($pruefziffer == 10) {
        $pruefziffer = 0 ;
      }
      if ($pruefziffer == $kontonummer[$pruefstelle]) {
        $return_value = 1;
      } else {
        $return_value = 0;
      }
    }
    if (($length <= 9) && ($length >= 6)) {
      // Hier Variante 1
      $overall = 0;
      $iteration = 1;
      $j = $length - 2;
      $pruefstelle = $length - 1;
      while ($iteration <= 9) {
        if (($iteration % 2) == 0) {
          $produkte[$iteration] = $kontonummer[$j] * 1;
          $produktcast = "$produkte[$iteration]";
          $this->quersumme[$iteration] = $produktcast;
        } else {
          $produkte[$iteration] = $kontonummer[$j] * 2;
          if ($produkte[$iteration] > 9) {
            $produktcast = "$produkte[$iteration]";
            $this->quersumme[$iteration] = $produktcast[0] + $produktcast[1];
          } else {
            $produktcast = "$produkte[$iteration]";
            $this->quersumme[$iteration] = $produktcast;
          }
        }
        $overall += $this->quersumme[$iteration];
        $iteration++;
        $j--;
      }
    }
    $stelle = strlen ($overall);
    $overallcast = "$overall";
    if ($stelle == 1) {
      $pruefziffer = 10 - $overallcast;
    } else {
      $pruefziffer = 10 - $overallcast [$stelle - 1];
    }
    if ($pruefziffer == 10) {
      $pruefziffer = 0 ;
    }
    if ($pruefziffer == $kontonummer[$pruefstelle]) {
      $return_value = 1;
    } else {
      // Hier Variante 2
      $overall = 0;
      $iteration = 1;
      $j = $length - 2;
      $pruefstelle = $length - 1;
      if (($length <= 9) && ($length >= 6)) {
        $pruefstelle = $length - 1;
        while ($iteration <= 9) {
          if (($iteration % 2) == 0) {
            $produkte[$iteration] = $kontonummer[$j] * 1;
            $produktcast = "$produkte[$iteration]";
            $this->quersumme[$iteration] = $produktcast;
          } else {
            $produkte[$iteration] = $kontonummer[$j] * 2;
            if ($produkte[$iteration] > 9) {
              $produktcast = "$produkte[$iteration]";
              $this->quersumme[$iteration] = $produktcast[0] + $produktcast[1];
            } else {
              $produktcast = "$produkte[$iteration]";
              $this->quersumme[$iteration] = $produktcast;
            }
          }
	  if (($iteration != 6) && ($iteration != 7)) {
            $overall += $this->quersumme[$iteration];
	  } else {
	    $overall = $overall;
	  }
          $iteration++;
          $j--;
        }
      }
      $stelle = strlen ($overall);
      $overallcast = "$overall";
      if ($stelle == 1) {
        $pruefziffer = 10 - $overallcast;
      } else {
        $pruefziffer = 10 - $overallcast [$stelle - 1];
      }
      if ($pruefziffer == 10) {
        $pruefziffer = 0 ;
      }
      if ($pruefziffer == $kontonummer[$pruefstelle]) {
        $return_value = 1;
      } else {
        $return_value = 0;
      }
    }
    if (($length == 9) && (intval ($kontonummer) >= 400000000) && (intval ($kontonummer) <= 499999999)) {
      $return_value = 3;
    }
    return $return_value;
  } // Ende 68

function verfahren_69 ($ktonr) {
  if (intval ($ktonr) >= 9300000000 && intval ($ktonr) <= 9399999999) {
    $returnValue = 1; // Dies Kontonummern sind immer gueltig
  } else {
    if (intval ($ktonr) <= 9700000000 || intval ($ktonr) >= 9799999999) {
      $returnValue = $this->verfahren_28 ($ktonr);
    }
    if (intval ($ktonr) >= 9700000000 && intval ($ktonr) <= 9799999999 || $returnValue == 0) {
      $returnValue = $this->verfahren_29 ($ktonr);
    }
  }
  return $returnValue;
} // Ende 69

function verfahren_70 ($ktonr) {

	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*3);
	$val1=intval(intval($ktonr[0])*4);

        if ($ktonr[3] == 5 || strval ($ktonr[3]) . strval ($ktonr[4]) == "69") {
	  $ges=intval($val4+$val5+$val6+$val7+$val8+$val9);
	} else {
	  $ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	}
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 70

  function verfahren_73 ($ktonr) {
    if (intval ($ktonr[2]) != 9) {
	$val9=intval(intval($ktonr[8])*1);
	$val8=intval(intval($ktonr[7])*2);
	$val7=intval(intval($ktonr[6])*1);
	$val6=intval(intval($ktonr[5])*2);
	$val5=intval(intval($ktonr[4])*1);
	$val4=intval(intval($ktonr[3])*2);
        $ges=intval($this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
    } else {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*8);
	$val2=intval(intval($ktonr[1])*9);
	$val1=intval(intval($ktonr[0])*10);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
    }
  } // Ende 73

function verfahren_76 ($ktonr) {
          $gut=0;
	  $val7=intval(intval($ktonr[6])*2);
	  $val6=intval(intval($ktonr[5])*3);
	  $val5=intval(intval($ktonr[4])*4);
	  $val4=intval(intval($ktonr[3])*5);
	  $val3=intval(intval($ktonr[2])*6);
	  $val2=intval(intval($ktonr[1])*7);
	  $ges=intval($val2+$val3+$val4+$val5+$val6+$val7);
	  $rest=$ges % 11;
	  if ($rest==intval($ktonr[7])) { return 1; $gut=1;}
	  else {
	  $val9=intval(intval($ktonr[8])*2);
	  $val8=intval(intval($ktonr[7])*3);
	  $val7=intval(intval($ktonr[6])*4);
	  $val6=intval(intval($ktonr[5])*5);
	  $val5=intval(intval($ktonr[4])*6);
	  $val4=intval(intval($ktonr[3])*7);
	  $ges=intval($val4+$val5+$val6+$val7+$val8+$val9);
	  $rest=$ges % 11;
	  if ($rest==intval($ktonr[9])) { return 1; $gut=1;}
	  }
          if (!$gut) { return 0; }
} // Ende 76

function verfahren_77 ($ktonr) {

	$val10=intval(intval($ktonr[9])*5);
	$val9=intval(intval($ktonr[8])*4);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);

	$ges=intval($val6+$val7+$val8+$val9+$val10);
	$rest=$ges % 11;
	if ($rest != 0) {
	  $val10=intval(intval($ktonr[9])*5);
	  $val9=intval(intval($ktonr[8])*4);
	  $val8=intval(intval($ktonr[7])*3);
	  $val7=intval(intval($ktonr[6])*4);
	  $val6=intval(intval($ktonr[5])*5);

	  $ges=intval($val6+$val7+$val8+$val9+$val10);
	  $rest=$ges % 11;
	  if ($rest != 0) {
	    return 0;
	  } else {
	    return 1;
	  }
	} else {
	  return 1;
	}
} // Ende 77

  function verfahren_78 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9]) && strlen (strval (intval ($ktonr))) != 8) { return 1; }
	else { return 0; }
  } // Ende 78

  function verfahren_79 ($ktonr) {
    if ($ktonr[0] >= 3 && $ktonr[0] <= 8 && $ktonr[0] != 0) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*1);
	$val1=intval(intval($ktonr[0])*2);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9]) && strlen (strval (intval ($ktonr))) != 8) { return 1; }
	else { return 0; }
    } else {
      if ($ktonr[0] != 0) {
	$val8=intval(intval($ktonr[7])*2);
	$val7=intval(intval($ktonr[6])*1);
	$val6=intval(intval($ktonr[5])*2);
	$val5=intval(intval($ktonr[4])*1);
	$val4=intval(intval($ktonr[3])*2);
	$val3=intval(intval($ktonr[2])*1);
	$val2=intval(intval($ktonr[1])*2);
	$val1=intval(intval($ktonr[0])*1);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[8]) && strlen (strval (intval ($ktonr))) != 8) { return 1; }
	else { return 0; }
      }
    }
  } // Ende 79

function verfahren_82 ($ktonr) {
  if (strval ($ktonr[2]) . strval ($ktonr[3]) == "99") {
    return $this->verfahren_10 ($ktonr);
  } else {
    return $this->verfahren_33 ($ktonr);
  }
} // Ende 82

function verfahren_88 ($ktonr) {
	if ($ktonr[2]==9) {
	  $val9=intval(intval($ktonr[8])*2);
	  $val8=intval(intval($ktonr[7])*3);
	  $val7=intval(intval($ktonr[6])*4);
	  $val6=intval(intval($ktonr[5])*5);
	  $val5=intval(intval($ktonr[4])*6);
	  $val4=intval(intval($ktonr[3])*7);
	  $ges=intval($val4+$val5+$val6+$val7+$val8+$val9);
        } else {
	  $val9=intval(intval($ktonr[8])*2);
	  $val8=intval(intval($ktonr[7])*3);
	  $val7=intval(intval($ktonr[6])*4);
	  $val6=intval(intval($ktonr[5])*5);
	  $val5=intval(intval($ktonr[4])*6);
	  $val4=intval(intval($ktonr[3])*7);
	  $val3=intval(intval($ktonr[2])*8);
	  $ges=intval($val3+$val4+$val5+$val6+$val7+$val8+$val9);
        }
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
} // Ende 88

function verfahren_95 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*3);
	$val1=intval(intval($ktonr[0])*4);
	if ($ktonr[0] != "0") {
	  if (($ktonr[3] == 5) || (($ktonr[3] == 6) && ($ktonr[4] == 9))) { $ges=intval($val4+$val5+$val6+$val7+$val8+$val9); }
	  else { $ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9); }
	  $rest=$ges % 11;
	  if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 
	  if (intval($pruef)==intval($ktonr[9])) { return 1; }
	  else { return 0; }
	} else {
	  if (($ktonr >= 1 && $ktonr <= 1999999) || ($ktonr >= 396000000 && $ktonr <= 499999999) || ($ktonr >= 700000000 && $ktonr <= 79999999)) {
	    return 3;
	  } else {
	    return 1;
	  }
	}
} // Ende 95

function verfahren_99 ($ktonr) {
  if (intval ($ktonr) >= 396000000 && intval ($ktonr) <= 499999999) {
        return 1;
  } else {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*3);
	$val7=intval(intval($ktonr[6])*4);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*6);
	$val4=intval(intval($ktonr[3])*7);
	$val3=intval(intval($ktonr[2])*2);
	$val2=intval(intval($ktonr[1])*3);
	$val1=intval(intval($ktonr[0])*4);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest>1) { $pruef=intval(11 - $rest); } else { $pruef=0; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  }
} // Ende 99

function verfahren_A0 ($ktonr) {
  if (intval ($ktonr) < 1000 || intval ($ktonr[0] . $ktonr[1] . $ktonr[2] . $ktonr[3] . $ktonr[4] . $ktonr[5] . $ktonr[6]) == 0) {
        return 1;
  } else {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*4);
	$val7=intval(intval($ktonr[6])*8);
	$val6=intval(intval($ktonr[5])*5);
	$val5=intval(intval($ktonr[4])*10);
	$val4=intval(intval($ktonr[3])*0);
	$val3=intval(intval($ktonr[2])*0);
	$val2=intval(intval($ktonr[1])*0);
	$val1=intval(intval($ktonr[0])*0);

	$ges=intval($val1+$val2+$val3+$val4+$val5+$val6+$val7+$val8+$val9);
	$rest=$ges % 11;
	if ($rest == 0 || $rest == 1) { $pruef=0; } else { $pruef=11-$rest; } 

	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  }
} // Ende A0

  function verfahren_A1 ($ktonr) {
	$val9=intval(intval($ktonr[8])*2);
	$val8=intval(intval($ktonr[7])*1);
	$val7=intval(intval($ktonr[6])*2);
	$val6=intval(intval($ktonr[5])*1);
	$val5=intval(intval($ktonr[4])*2);
	$val4=intval(intval($ktonr[3])*1);
        $ges=intval($this->quersumme($val1)+$this->quersumme($val2)+$this->quersumme($val3)+$this->quersumme($val4)+$this->quersumme($val5)+$this->quersumme($val6)+$this->quersumme($val7)+$this->quersumme($val8)+$this->quersumme($val9));
	$ges = strval ($ges);
	$gesLength = strlen ($ges);
	if ($gesLength > 1) {
	  for ($i = 1; $i < $gesLength; $i++) {
	    $gesEiner = $ges[$i];
	  }
	} else {
	  $gesEiner = $ges;
	}
	$rest=10-intval($gesEiner % 10);
	if ($rest==10) { $pruef=0; } else { $pruef=$rest; }
	if (intval($pruef)==intval($ktonr[9])) { return 1; }
	else { return 0; }
  } // Ende A1

  function quersumme ($zahl) {
    $zahlStr = strval ($zahl);
    $zahl = "";
    for ($i=0; $i <= strlen ($zahlStr) - 1; $i++) {
      $zahl += intval ($zahlStr[$i]);
    }
    return $zahl;
  }

  function getDir () {
    $pfad = "";
    $scriptName = realpath ("./kontocheck.class.php");
    $subDir = explode ("/", $scriptName);
    for ($i = 0; $i <= sizeof ($subDir) - 1; $i++) {
      if ($i != 0 && $i != sizeof ($subDir) - 1) {
        $pfad .= "/" . $subDir[$i];
      }
    }
    $pfad .= "/";
    return $pfad;
  }

  function getBankInfo ($blz) {
    $blzZeile = $this->bankHash["$blz"];
    return $blzZeile;
  }

  function validateAccount ($kontonummer, $blz) {
    $bankHash = &$this->bankHash;
    $kontonummer = preg_replace ("/ /", "", $kontonummer);
    $blz = preg_replace ("/ /", "", $blz);
    $kontonummer = preg_replace ("/-/", "", $kontonummer);
    $blz = preg_replace ("/-/", "", $blz);
    $kontonummer = preg_replace ("/\,/", "", $kontonummer);
    $blz = preg_replace ("/\,/", "", $blz);
    $kontonummer = preg_replace ("/\./", "", $kontonummer);
    $blz = preg_replace ("/\./", "", $blz);
    if (!is_numeric ($kontonummer)) {
      $returnValue = 0;
    } else {
      if (isset ($bankHash)) {
        $blz = intval ($blz);
        $blzZeile = $bankHash["$blz"];
        $verfahren = strval (chop ($blzZeile["verfahren"]));
	// Testcode
        // $verfahren = 77;
        $laenge = strlen ($kontonummer);
        if ($laenge < 10) {
          $zerosToAdd = 10 - $laenge;
          $i = 1;
          while ($i <= $zerosToAdd) {
            $kontonummer = "0". $kontonummer;
    	    $i++;
          }
        }
        $kontonummer = strval($kontonummer);
        if ($kontonummer <= 9 || $blz <= 1000000) {
          $returnValue = 0;
        } else {
          // Class extenstion
          $functionName = "verfahren_" . $verfahren;
          if (method_exists ($this,$functionName)) {
	    $returnValue = call_user_method($functionName,$this, ($kontonummer));
	  } else {
	    if (sizeof ($blzZeile) > 0) {
              $returnValue = 3;
	    } else {
              $returnValue = 0;
	    }
	  }
        }
      } else {
        $returnValue = 0;
      }
    }
    return $returnValue;
  }

} // End class kontocheck

?>